--- pkcs11/wrap-layer/mock-secret-store.c.orig	2014-04-20 22:59:11.000000000 -0700
+++ pkcs11/wrap-layer/mock-secret-store.c	2014-04-20 23:09:50.000000000 -0700
@@ -32,6 +32,43 @@
 
 EGG_SECURE_DEFINE_GLIB_GLOBALS ();
 
+#ifdef __APPLE__
+#include <Availability.h>
+#if __MAC_OS_X_VERSION_MIN_REQUIRED <= 1060
+#define memmem mp_memmem
+#endif
+#endif
+
+static void *
+mp_memmem(const void *b1, size_t len1, const void *b2, size_t len2);
+
+static void *
+mp_memmem(const void *b1, size_t len1, const void *b2, size_t len2)
+{
+        /* Initialize search pointer */
+        char *sp = (char *) b1;
+
+        /* Initialize pattern pointer */
+        char *pp = (char *) b2;
+
+        /* Intialize end of search address space pointer */
+        char *eos   = sp + len1 - len2;
+
+        /* Sanity check */
+        if(!(b1 && b2 && len1 && len2))
+                return NULL;
+
+        while (sp <= eos) {
+                if (*sp == *pp)
+                        if (memcmp(sp, pp, len2) == 0)
+                                return sp;
+
+                        sp++;
+        }
+
+        return NULL;
+}
+
 static CK_RV
 mock_secret_C_Initialize (CK_VOID_PTR pInitArgs)
 {
